// Variables
var password;
var hotMeterMinLevel;
var warmMeterMinLevel;
var microphoneType;

var mic1canvasfg, mic1contextfg, mic1canvasbg, mic1contextbg;
var mic2canvasfg, mic2contextfg, mic2canvasbg, mic2contextbg;
var softCodecCanvasfg, softCodecCanvasfgContext, softCodecCanvasbg, softCodecCanvasbgContext;
var headsetCanvasfg, headsetCanvasfgContext, headsetCanvasbg, headsetCanvasbgContext;
var outputCanvasfg, outputCanvasfgContext, outputCanvasbg, outputCanvasbgContext;
var aecCanvasfg, aecCanvasfgContext, aecCanvasbg, aecCanvasbgContext;
var noiseGatecanfg, noiseGatecanfgContext, noiseGatecanbg, noiseGatecanbgContext

// Constants
var multiColorlabels = [10, 0, -10, -20, -30, -40, -50, -60, -70, -80, -90, -100];
var erleLabels = [40, 35, 30, 25, 20, 15, 10, 5, 0];
var erlLabels = [25, 20, 15, 10, 5, 0, -5, -10, -15, -20, -25];
var attenuationLabels = [0, -3, -6, -9, -12, -15, -18, -21, -23, -25];

var meterHeight = 140;
var meterWidth = 27;
var meterBorder = 1;
var meterX = 40;
var meterY = 20;
var meterGap = 50;
var agcMeterGap = 100;
var azimuthXOffset = meterX + 620;
var capsuleMeterCount = 8;
var meterMax = 10;
var meterMin = -100;
var warmMeterMin = -25;
var hotMeterMin = 0;
var levelWidth = meterWidth - (meterBorder * 2);
var erlMin = -25;
var erlMax = 25;
var erleMin = 0;
var erleMax = 40;
var textYOffset = 3;
var textXOffset = 14;
var minus120dB = 0.000001;

// Peak meter stuff
var meterPeakCount = 0;
var softCodecInputMeterPeak = [meterMin];
var softCodecOutputMeterPeak = [meterMin];
var headsetInputMeterPeak = [meterMin];
var headsetOutputMeterPeak = [meterMin];
var outputAmpMeterPeak = [meterMin];
var outputRCAMeterPeak = [meterMin];
var aec1MeterPeaks = [meterMin,meterMin,meterMin];
var aec2MeterPeaks = [meterMin,meterMin,meterMin];
var mic1InputMeterPeak = [meterMin];
var mic1CapsuleMeterPeaks = [meterMin,meterMin,meterMin,meterMin,meterMin,meterMin,meterMin,meterMin];
var mic2InputMeterPeak = [meterMin];
var mic2CapsuleMeterPeaks = [meterMin,meterMin,meterMin,meterMin,meterMin,meterMin,meterMin,meterMin];
var headsetMeterPeaks = [meterMin,0,meterMin]; // note we don't draw peak meters for the attenuation meter.

// Colors
var colors = {
	offRedColor : '#600000',
    offYellowColor : '#404000',
    offGreenColor : '#004000',
    onRedColor : '#FF0000',
    onYellowColor : '#FFFF00',
    onGreenColor : '#00FF00',
    bottomMarkerColor : "#32CD32",
    leftMarkerColor : "#4D82B8",
    rightMarkerColor : "#FF0000",
	disabledMarkerColor : "#252526"
}

function startup() {
    var loginButton = document.getElementById('loginButton');
    loginButton.onclick = function () {
        login();
    }

    var passwordInput = document.getElementById('passwordInput');
    passwordInput.onkeypress = function (e) {
        if (e.keyCode == 13) {
            login();
        }
    }

    var softCodecInputGain = document.getElementById('softCodecInputGain');
    softCodecInputGain.onchange = function () {
        save();
    }

    var headsetInputGain = document.getElementById('headsetInputGain');
    headsetInputGain.onchange = function () {
        save();
    }

    var ampLoadImpedance = document.getElementById('ampLoadImpedance');
    ampLoadImpedance.onchange = function () {
        save();
    }

    var micLocationCh1 = document.getElementById('micLocationCh1');
    micLocationCh1.onchange = function () {
        save();
    }

    var micTrackingEnableCh1 = document.getElementById('micTrackingEnableCh1');
    micTrackingEnableCh1.onchange = function () {
        save();
    }

    var micLocationCh2 = document.getElementById('micLocationCh2');
    micLocationCh2.onchange = function () {
        save();
    }

    var micTrackingEnableCh2 = document.getElementById('micTrackingEnableCh2');
    micTrackingEnableCh2.onchange = function () {
        save();
    }

    var ampOutputLevel = document.getElementById('ampOutputLevel');
    ampOutputLevel.onchange = function () {
        save();
    }

    var lineOutputLevel = document.getElementById('lineOutputLevel');
    lineOutputLevel.onchange = function () {
        save();
    }

    var overrideAmpLevel = document.getElementById('overrideAmpLevel');
    overrideAmpLevel.onchange = function () {
		save();
		ampOutputLevel.readOnly = overrideAmpLevel.checked == false;				
    }

    var overrideRCALevel = document.getElementById('overrideRCALevel');
    overrideRCALevel.onchange = function () {
		save();
		lineOutputLevel.readOnly = overrideRCALevel.checked == false;		
    }

    var overrideAutoSetupEq = document.getElementById('overrideAutoSetupEq');
    overrideAutoSetupEq.onchange = function () {
        save();
        updateLoudspeakerEqCombos();
    }

    var bypassAEC = document.getElementById('bypassAEC');
    bypassAEC.onchange = function () {
        save();
    }

    var aecNoiseReduction = document.getElementById('aecNoiseReduction');
    aecNoiseReduction.onchange = function () {
        save();
    }

    var aecEchoSuppression = document.getElementById('aecEchoSuppression');
    aecEchoSuppression.onchange = function () {
        save();
    }

    var bypassAGC = document.getElementById('bypassAGC');
    bypassAGC.onchange = function () {
        save();
    }
    
    var bfElevatOverrideCh1 = document.getElementById('bfElevatOverrideCh1');
    bfElevatOverrideCh1.onchange = function () {
        save();
    }

    var bfElevatOverrideCh2 = document.getElementById('bfElevatOverrideCh2');
    bfElevatOverrideCh2.onchange = function () {
        save();
    }
    
    var micLowCutEq = document.getElementById('micLowCutEq');
    micLowCutEq.onchange = function () {
        save();
    }

    var micMidBoostEq = document.getElementById('micMidBoostEq');
    micMidBoostEq.onchange = function () {
        save();
    }

    var balancedRCAOuts = document.getElementById('balancedRCAOuts');
    balancedRCAOuts.onchange = function () {
        save();
    }

    var persistOverride = document.getElementById('persistOverride');
    persistOverride.onchange = function () {
        save();
    }
    
    var disableMicMuteSwitch = document.getElementById('disableMicMuteSwitch');
    disableMicMuteSwitch.onchange = function () {
        save();
    }

    var autoSetupBassEq = document.getElementById('autoSetupBassEq');
    autoSetupBassEq.onchange = function () {
        save();
    }
    
    var autoSetupMidEq = document.getElementById('autoSetupMidEq');
    autoSetupMidEq.onchange = function () {
        save();
    }

    var autoSetupTrebleEq = document.getElementById('autoSetupTrebleEq');
    autoSetupTrebleEq.onchange = function () {
        save();
    }
    
    var bypassNoiseGate = document.getElementById('bypassNoiseGate');
    bypassNoiseGate.onchange = function () {
        save();
    }
    
 	var noiseGateAttack = document.getElementById('noiseGateAttack');
    noiseGateAttack.onchange = function () {
        save();
    }    
    
 	var noiseGateRelease = document.getElementById('noiseGateRelease');
    noiseGateRelease.onchange = function () {
        save();
    }
    
    var noiseGateThreshold = document.getElementById('noiseGateThreshold');
    noiseGateThreshold.onchange = function () {
        save();
    }
    
    mic1canvasfg = document.getElementById('canfg');
    mic1canvasbg = document.getElementById('canbg');
    mic1contextbg = mic1canvasbg.getContext('2d');
    mic1contextfg = mic1canvasfg.getContext('2d');

    mic2canvasfg = document.getElementById('mic2canfg');
    mic2canvasbg = document.getElementById('mic2canbg');
    mic2contextbg = mic2canvasbg.getContext('2d');
    mic2contextfg = mic2canvasfg.getContext('2d');

    softCodecCanvasfg = document.getElementById('softCodecCanfg');
    softCodecCanvasfgContext = softCodecCanvasfg.getContext('2d');
    softCodecCanvasbg = document.getElementById('softCodecCanbg');
    softCodecCanvasbgContext = softCodecCanvasbg.getContext('2d');

    headsetCanvasfg = document.getElementById('headsetCanfg');
    headsetCanvasfgContext = headsetCanvasfg.getContext('2d');
    headsetCanvasbg = document.getElementById('headsetCanbg');
    headsetCanvasbgContext = headsetCanvasbg.getContext('2d');

    outputCanvasfg = document.getElementById('outputCanfg');
    outputCanvasfgContext = outputCanvasfg.getContext('2d');
    outputCanvasbg = document.getElementById('outputCanbg');
    outputCanvasbgContext = outputCanvasbg.getContext('2d');

    aecCanvasfg = document.getElementById('aecCanvasfg');
    aecCanvasfgContext = aecCanvasfg.getContext('2d');
    aecCanvasbg = document.getElementById('aecCanvasbg');
    aecCanvasbgContext = aecCanvasbg.getContext('2d');
    
	noiseGatecanfg = document.getElementById('noiseGatecanfg');
	noiseGatecanfgContext = noiseGatecanfg.getContext('2d');
	
	noiseGatecanbg = document.getElementById('noiseGatecanbg');
	noiseGatecanbgContext = noiseGatecanbg.getContext('2d');
}

function login() {
    password = document.getElementById('passwordInput').value;

    if (password != '') {
        $.ajax({
            type: "post",
            cache: false,
            data: {
                action: "login",
                userPassword: password
            },
            url: "",
            success: function (result) {
                obj = JSON.parse(result);

                if (obj.hasOwnProperty("responseError")) {
                    if (obj.responseError != "") {
                        alert(obj.responseError);

                        return;
                    }
                }

                // Check the microphone type
                microphoneType = parseInt(obj.microphoneType);
				populateLocationCombos(microphoneType);
				
                var el = document.getElementById('softCodecInputGain');
                el.value = obj.softCodecInputGain;

                el = document.getElementById('headsetInputGain');
                el.value = obj.headsetInputGain;

                el = document.getElementById('ampLoadImpedance');
                el.value = obj.ampLoadImpedance == "4" ? "4 ohm" : "8 ohm";

                el = document.getElementById('micLocationCh1');
                el.selectedIndex = parseInt(obj.micLocationCh1);

                el = document.getElementById('micTrackingEnableCh1');
                el.checked = obj.micTrackingEnableCh1 == "true";

                el = document.getElementById('micLocationCh2');
                el.selectedIndex = parseInt(obj.micLocationCh2);

                el = document.getElementById('micTrackingEnableCh2');
                el.checked = obj.micTrackingEnableCh2 == "true";

                el = document.getElementById('overrideAmpLevel');
                el.checked = obj.overrideAmpLevel == "true";

                el = document.getElementById('ampOutputLevel');
                el.value = obj.ampOutputLevel;
				el.readOnly = obj.overrideAmpLevel == "false";

                el = document.getElementById('overrideRCALevel');
                el.checked = obj.overrideRCALevel == "true";
				
                el = document.getElementById('lineOutputLevel');
                el.value = obj.lineOutputLevel;
				el.readOnly = obj.overrideRCALevel == "false";
				
                el = document.getElementById('overrideAutoSetupEq');
                el.checked = obj.overrideAutoSetupEq == "true";

                el = document.getElementById('bypassAEC');
                el.checked = obj.bypassAEC == "true";

                el = document.getElementById('aecNoiseReduction');
                el.selectedIndex = parseInt(obj.aecNoiseReduction);

                el = document.getElementById('aecEchoSuppression');
                el.selectedIndex = parseInt(obj.aecEchoSuppression);

                el = document.getElementById('bypassAGC');
                el.checked = obj.bypassAGC == "true";

                el = document.getElementById('disableMicMuteSwitch');
                el.checked = obj.disableMicMuteSwitch == "true";
                
                el = document.getElementById('balancedRCAOuts');
                el.checked = obj.balancedRCAOuts == "true";
                
                el = document.getElementById('persistOverride');
                el.checked = obj.persistOverride == "true";
                
                el = document.getElementById('micLowCutEq');
                el.selectedIndex = parseInt(obj.micLowCutEq);
                
                el = document.getElementById('micMidBoostEq');
                el.selectedIndex = parseInt(obj.micMidBoostEq);

                el = document.getElementById('autoSetupBassEq');
                el.selectedIndex = parseInt(obj.autoSetupBassEq);

                el = document.getElementById('autoSetupMidEq');
                el.selectedIndex = parseInt(obj.autoSetupMidEq);

                el = document.getElementById('autoSetupTrebleEq');
                el.selectedIndex = parseInt(obj.autoSetupTrebleEq);

  
                el = document.getElementById('bypassNoiseGate');
                el.checked = obj.bypassNoiseGate == "true";
                
 				var el = document.getElementById('noiseGateAttack');
                el.value = obj.noiseGateAttack;                

 				var el = document.getElementById('noiseGateRelease');
                el.value = obj.noiseGateRelease;                

 				var el = document.getElementById('noiseGateThreshold');
                el.value = obj.noiseGateThreshold;                


                // Set mic 1 elevation combo selected index                
                var strArray = obj.bfElevationRangeCh1.split(",");
                var bfMinElevationCh1 = parseInt(strArray[0]);
                var bfMaxElevationCh1 = parseInt(strArray[1]);
                el = document.getElementById('bfElevatOverrideCh1');				
				el.selectedIndex = GetElevationComboSelectedIndex(bfMinElevationCh1, bfMaxElevationCh1, microphoneType);
                                
                // Set mic 2 elevation combo selected index
                strArray = obj.bfElevationRangeCh2.split(",");
                var bfMinElevationCh2 = parseInt(strArray[0]);
                var bfMaxElevationCh2 = parseInt(strArray[1]);
                el = document.getElementById('bfElevatOverrideCh2');
				el.selectedIndex = GetElevationComboSelectedIndex(bfMinElevationCh2, bfMaxElevationCh2, microphoneType);
			  
			  	updateLoudspeakerEqCombos();
			  	              
                $('#wrapper').focus(); // Stop cursor blinking in IE!
                advancedSection.setAttribute('class', 'visible');
                loginSection.setAttribute('class', 'hidden');
                prepareMeteringCanvas();
                startMeteringBasic();
            },
            error: function (jqXHR, textStatus, errorThrown) {
                alert(errorThrown)
            }
        });
    }
    else {
        alert("Please login!");
    }
}

function GetElevationComboSelectedIndex(minElevation, maxElevation, micType) {
	if (minElevation == 0 && maxElevation == 30) 
	{
		return 0; // select to 0 to 30
	}
	else if (minElevation == 15 && maxElevation == 45)
	{
		return 1; // select to 15 to 45
	}
	else if (minElevation == 30 && maxElevation == 60)
	{
		return 2; // select to 30 to 60                
	}
	else if (minElevation == 45 && maxElevation == 75)
	{
		return 3; // select to 45 to 75
	}
	else
	{
		if (micType == "2")
		{                
			return 2; // default to 30 to 60 for DCM1
		}
		else
		{
			return 1; // default to 15 to 45 for DTM1               	
		}
	}
}

function save() {
    password = document.getElementById('passwordInput').value;

    if (password != '') {
        var softCodecInputGain = document.getElementById('softCodecInputGain').value;
        var headsetInputGain = document.getElementById('headsetInputGain').value;
        var ampLoadImpedance = document.getElementById('ampLoadImpedance').value == "4 ohm" ? 4 : 8;
        var micLocationCh1 = document.getElementById('micLocationCh1').selectedIndex;
        var micTrackingEnableCh1 = document.getElementById('micTrackingEnableCh1').checked ? "true" : "false";
        
        // Channel 1 elevation override calcs
        var bfElevatOverrideCh1SelectedIndex = document.getElementById('bfElevatOverrideCh1').selectedIndex;
        var bfElevationRangeCh1;
        
        switch (bfElevatOverrideCh1SelectedIndex) {
        	case 0:
        		bfElevationRangeCh1 = "0.0,30.0";
        		break;
        	case 2:
        		bfElevationRangeCh1 = "30.0,60.0";
        		break;
        	case 3:
        		bfElevationRangeCh1 = "45.0,75.0";
        		break;
        	default:
        		bfElevationRangeCh1 = "15.0,45.0";
        		break;
        }
       
        var micLocationCh2 = document.getElementById('micLocationCh2').selectedIndex;
        var micTrackingEnableCh2 = document.getElementById('micTrackingEnableCh2').checked ? "true" : "false";
        
        // Channel 2 elevation override calcs
        var bfElevatOverrideCh2SelectedIndex = document.getElementById('bfElevatOverrideCh2').selectedIndex;
        var bfElevationRangeCh2;
        switch (bfElevatOverrideCh2SelectedIndex) {
        	case 0:
        		bfElevationRangeCh2 = "0.0,30.0";
        		break;
        	case 2:
        		bfElevationRangeCh2 = "30.0,60.0";
        		break;
        	case 3:
        		bfElevationRangeCh2 = "45.0,75.0";
        		break;
        	default:
        		bfElevationRangeCh2 = "15.0,45.0";
        		break;
        }

        var ampOutputLevelValue = document.getElementById('ampOutputLevel').value;
        var lineOutputLevelValue = document.getElementById('lineOutputLevel').value;
        var overrideAmpLevelValue = document.getElementById('overrideAmpLevel').checked ? "true" : "false";
        var overrideRCALevelValue = document.getElementById('overrideRCALevel').checked ? "true" : "false";
        var overrideAutoSetupEqValue = document.getElementById('overrideAutoSetupEq').checked ? "true" : "false";

        var bypassAECValue = document.getElementById('bypassAEC').checked ? "true" : "false";
        var aecNoiseReductionValue = document.getElementById('aecNoiseReduction').selectedIndex;
        var aecEchoSuppressionValue = document.getElementById('aecEchoSuppression').selectedIndex;
        var bypassAGCValue = document.getElementById('bypassAGC').checked ? "true" : "false";
        var balancedRCAOutsValue = document.getElementById('balancedRCAOuts').checked ? "true" : "false";
        var persistOverrideValue = document.getElementById('persistOverride').checked ? "true" : "false";
        var micLowCutEqValue = document.getElementById('micLowCutEq').selectedIndex;
        var micMidBoostEqValue = document.getElementById('micMidBoostEq').selectedIndex;
		var disableMicMuteSwitchValue = document.getElementById('disableMicMuteSwitch').checked ? "true" : "false";
		
		var autoSetupBassEqValue = document.getElementById('autoSetupBassEq').selectedIndex;
		var autoSetupMidEqValue = document.getElementById('autoSetupMidEq').selectedIndex;
		var autoSetupTrebleEqValue = document.getElementById('autoSetupTrebleEq').selectedIndex;
		
		var	bypassNoiseGateValue = document.getElementById('bypassNoiseGate').checked ? "true" : "false";;
 		var	noiseGateAttackValue = document.getElementById('noiseGateAttack').value;
 		var	noiseGateReleaseValue = document.getElementById('noiseGateRelease').value;
    	var	noiseGateThresholdValue = document.getElementById('noiseGateThreshold').value;
		
        $.ajax({
            type: "post",
            cache: false,
            data: {
                action: "saveAdvanced",
                userPassword: password,
                softCodecInputGain: softCodecInputGain,
                headsetInputGain: headsetInputGain,
                ampLoadImpedance: ampLoadImpedance,
                micLocationCh1: micLocationCh1,
                micTrackingEnableCh1: micTrackingEnableCh1,
                micLocationCh2: micLocationCh2,
                micTrackingEnableCh2: micTrackingEnableCh2,
                bfElevationRangeCh1: bfElevationRangeCh1,
                bfElevationRangeCh2: bfElevationRangeCh2,
                ampOutputLevel: ampOutputLevelValue,
                lineOutputLevel: lineOutputLevelValue,
                overrideAmpLevel: overrideAmpLevelValue,
                overrideRCALevel: overrideRCALevelValue,
                overrideAutoSetupEq: overrideAutoSetupEqValue,
                bypassAEC: bypassAECValue,
                aecNoiseReduction: aecNoiseReductionValue,
                aecEchoSuppression: aecEchoSuppressionValue,
                bypassAGC: bypassAGCValue,
				balancedRCAOuts: balancedRCAOutsValue,
				persistOverride: persistOverrideValue,
				micLowCutEq: micLowCutEqValue,
				micMidBoostEq: micMidBoostEqValue,
				disableMicMuteSwitch: disableMicMuteSwitchValue,
				autoSetupBassEq: autoSetupBassEqValue,
				autoSetupMidEq: autoSetupMidEqValue,
				autoSetupTrebleEq: autoSetupTrebleEqValue,
				bypassNoiseGate: bypassNoiseGateValue,
				noiseGateAttack: noiseGateAttackValue,
				noiseGateRelease: noiseGateReleaseValue,
				noiseGateThreshold: noiseGateThresholdValue
            },
            url: "",
            success: function (result) {
                obj = JSON.parse(result);

                if (obj.hasOwnProperty("responseError")) {
                    if (obj.responseError != "") {
                        alert(obj.responseError);

                        return;
                    }
                }
            },
            error: function (jqXHR, textStatus, errorThrown) {
                alert(errorThrown)
            }
        });
    }
    else {
        alert("Please login!");
    }
}

function startMeteringBasic() {
    $.ajax({
        type: "post",
        cache: false,
        data: {
            action: 'startMeteringBasic',
            userPassword: password
        },
        url: "",
        success: function (result) {

            if (result != "") {
                obj = JSON.parse(result);
				
                // Soft Codec
                var softCodecInputMeter = obj.softCodecInputMeter.split(',');
                drawMeters(softCodecCanvasfgContext, softCodecCanvasfg, softCodecInputMeter, 0, meterX, meterY, 1, meterWidth, meterHeight, 0, true, true, "", meterMin, meterMax, softCodecInputMeterPeak);

                var softCodecOutputMeter = obj.softCodecOutputMeter.split(',');
                drawMeters(softCodecCanvasfgContext, softCodecCanvasfg, softCodecOutputMeter, 0, meterX + meterWidth + meterGap, meterY, 1, meterWidth, meterHeight, 0, true, true, "", meterMin, meterMax, softCodecOutputMeterPeak);

                // Headset
				var enableHeadset = obj.enableHeadset == "true";
                var headsetInputMeter = obj.headsetInputMeter.split(',');                
                var headsetOutputMeter = obj.headsetOutputMeter.split(',');

                if (enableHeadset == false)
                {
					headsetInputMeter = [meterMin, 0];
					headsetOutputMeter = [meterMin, 0];
				}

               	drawMeters(headsetCanvasfgContext, headsetCanvasfg, headsetInputMeter, 0, meterX, meterY, 1, meterWidth, meterHeight, 0, true, true, "", meterMin, meterMax, headsetInputMeterPeak);
                drawMeters(headsetCanvasfgContext, headsetCanvasfg, headsetOutputMeter, 0, meterX + meterWidth + meterGap, meterY, 1, meterWidth, meterHeight, 0, true, true, "", meterMin, meterMax, headsetOutputMeterPeak);
				
                // Output
                var ampOutputMeter = obj.ampOutputMeter.split(',');
                drawMeters(outputCanvasfgContext, outputCanvasfg, ampOutputMeter, 0, meterX, meterY, 1, meterWidth, meterHeight, 0, true, true, "", meterMin, meterMax, outputAmpMeterPeak);

                var lineOutputMeter = obj.lineOutputMeter.split(',');
                drawMeters(outputCanvasfgContext, outputCanvasfg, lineOutputMeter, 0, meterX + meterWidth + meterGap, meterY, 1, meterWidth, meterHeight, 0, true, true, "", meterMin, meterMax, outputRCAMeterPeak);
				
                // AEC 1
                var aecMeters = obj.aecMetersCh1.split(',');
				
				if (obj.numberOfMicrophones < 1)
				{
					aecMeters[0] = meterMin;
					aecMeters[1] = -25;
					aecMeters[2] = 0;
				}
				else
				{
					// clamp the aec 1 ref meter
             		if (aecMeters[0] < meterMin)
                	{
	                	aecMeters[0] = meterMin;
                	}
				}
				
                drawMeters(aecCanvasfgContext, aecCanvasfg, aecMeters, 0, meterX, meterY, 1, meterWidth, meterHeight, 0, false, true, "", meterMin, meterMax, aec1MeterPeaks);
                drawMeters(aecCanvasfgContext, aecCanvasfg, aecMeters, 1, meterX + meterWidth + meterGap, meterY, 1, meterWidth, meterHeight, 0, false, false, colors.onRedColor, erlMin, erlMax, aec1MeterPeaks);
                drawMeters(aecCanvasfgContext, aecCanvasfg, aecMeters, 2, meterX + ((meterWidth + meterGap) * 2), meterY, 1, meterWidth, meterHeight, 0, false, false, colors.onRedColor, erleMin, erleMax, aec1MeterPeaks);

                // AEC 2
                aecMeters = obj.aecMetersCh2.split(',');
				
				if (obj.numberOfMicrophones < 2)
				{
					aecMeters[0] = meterMin;
					aecMeters[1] = -25;
					aecMeters[2] = 0;
				}
				else
				{
					// clamp the aec 2 ref meter
             		if (aecMeters[0] < meterMin)
                	{
	                	aecMeters[0] = meterMin;
                	}
                }	
				
                drawMeters(aecCanvasfgContext, aecCanvasfg, aecMeters, 0, meterX + agcMeterGap + ((meterWidth + meterGap) * 3), meterY, 1, meterWidth, meterHeight, 0, false, true, "", meterMin, meterMax, aec2MeterPeaks);
                drawMeters(aecCanvasfgContext, aecCanvasfg, aecMeters, 1, meterX + agcMeterGap + ((meterWidth + meterGap) * 4), meterY, 1, meterWidth, meterHeight, 0, false, false, colors.onRedColor, erlMin, erlMax, aec2MeterPeaks);
                drawMeters(aecCanvasfgContext, aecCanvasfg, aecMeters, 2, meterX + agcMeterGap + ((meterWidth + meterGap) * 5), meterY, 1, meterWidth, meterHeight, 0, false, false, colors.onRedColor, erleMin, erleMax, aec2MeterPeaks);

				if (obj.numberOfMicrophones > 0)
				{
					micTrackingEnableCh1.disabled = false;
					
					if (obj.microphoneType == "1")
					{
						bfElevatOverrideCh1.disabled = true;
						micLocationCh1.disabled = false;
						micLocationCh2.disabled = false;
					}
					else
					{
						bfElevatOverrideCh1.disabled = false;
						micLocationCh1.disabled = true;
						micLocationCh2.disabled = true;
					}
					
					if (obj.numberOfMicrophones > 1)
					{
						micTrackingEnableCh2.disabled = false;
						
						if (obj.microphoneType == "1")
						{
							bfElevatOverrideCh2.disabled = true;
							micLocationCh2.disabled = false;
						}
						else
						{
							bfElevatOverrideCh2.disabled = false;
							micLocationCh2.disabled = true;
						}
					}
					else
					{
						micLocationCh2.disabled = true;
						micTrackingEnableCh2.disabled = true;
						bfElevatOverrideCh2.disabled = true;
					}
				}
				else
				{
					micLocationCh1.disabled = true;
					micTrackingEnableCh1.disabled = true;
					bfElevatOverrideCh1.disabled = true;
					
					micLocationCh2.disabled = true;
					micTrackingEnableCh2.disabled = true;
					bfElevatOverrideCh2.disabled = true;
				}
				
				// Mic 1					
				var micInput1 = obj.micInputMeterCh1.split(',');
				drawMeters(mic1contextfg, mic1canvasfg, micInput1, 0, meterX, meterY, 1, meterWidth, meterHeight, 0, false, true, "", meterMin, meterMax, mic1InputMeterPeak);                
				
				var micCapsMetersCh1 = obj.micCapsMetersCh1.split(',');
				drawMeters(mic1contextfg, mic1canvasfg, micCapsMetersCh1, 0, meterX + 120, meterY, capsuleMeterCount, meterWidth, meterHeight, 25, true, true, "", meterMin, meterMax, mic1CapsuleMeterPeaks);

				if (obj.numberOfMicrophones > 0)
				{
					var micLocation = document.getElementById('micLocationCh1').selectedIndex;
					var bfAzimuthAngleCh1 = obj.bfAzimuthAngleCh1.split(',');
					drawAzimuth(mic1contextfg, bfAzimuthAngleCh1[0], bfAzimuthAngleCh1[2], bfAzimuthAngleCh1[4],
						bfAzimuthAngleCh1[1], bfAzimuthAngleCh1[3], bfAzimuthAngleCh1[5], azimuthXOffset, meterY + 80, 74, micLocation == "1");
				}
				else
				{
					drawAzimuth(mic1contextfg, 0, 0, 0,	0, 0, 0, azimuthXOffset, meterY + 80, 74, false);
				}

                // Mic 2
                var micInput2 = obj.micInputMeterCh2.split(',');
                drawMeters(mic2contextfg, mic2canvasfg, micInput2, 0, meterX, meterY, 1, meterWidth, meterHeight, 0, false, true, "", meterMin, meterMax, mic2InputMeterPeak);

                var micCapsMetersCh2 = obj.micCapsMetersCh2.split(',');
                drawMeters(mic2contextfg, mic2canvasfg, micCapsMetersCh2, 0, meterX + 120, meterY, capsuleMeterCount, meterWidth, meterHeight, 25, true, true, "", meterMin, meterMax, mic2CapsuleMeterPeaks);

				if (obj.numberOfMicrophones > 1)
				{
					var micLocation = document.getElementById('micLocationCh2').selectedIndex;
					var bfAzimuthAngleCh2 = obj.bfAzimuthAngleCh2.split(',');
					drawAzimuth(mic2contextfg, bfAzimuthAngleCh2[0], bfAzimuthAngleCh2[2], bfAzimuthAngleCh2[4],
						bfAzimuthAngleCh2[1], bfAzimuthAngleCh2[3], bfAzimuthAngleCh2[5], azimuthXOffset, meterY + 80, 74, micLocation == "1");
				}
				else
				{
					drawAzimuth(mic2contextfg, 0, 0, 0,	0, 0, 0, azimuthXOffset, meterY + 80, 74, false);
				}
				
				/* Draw Noise Gate Meters */
				var noiseGateMeters = obj.noiseGateMeters.split(',');
                drawMeters(noiseGatecanfgContext, noiseGatecanfg, noiseGateMeters, 0, meterX, meterY, 1, meterWidth, meterHeight, 0, false, true, "", meterMin, meterMax, headsetMeterPeaks);				
				drawMeters(noiseGatecanfgContext, noiseGatecanfg, noiseGateMeters, 1, meterX + meterWidth + meterGap, meterY, 1, meterWidth, meterHeight, 0, false, false, colors.onRedColor, 0, meterMin, headsetMeterPeaks);
				drawMeters(noiseGatecanfgContext, noiseGatecanfg, noiseGateMeters, 2, meterX + ((meterWidth + meterGap) * 2), meterY, 1, meterWidth, meterHeight, 0, false, true, "", meterMin, meterMax, headsetMeterPeaks);
				
				meterPeakCount += 1;
				
				if (meterPeakCount > 35)
				{
					meterPeakCount = 0;
					mic1InputMeterPeak[0] = meterMin;
					mic2InputMeterPeak[0] = meterMin;
					softCodecInputMeterPeak[0] = meterMin;
					softCodecOutputMeterPeak[0] = meterMin;
					outputAmpMeterPeak[0] = [meterMin];
					outputRCAMeterPeak[0] = [meterMin];
					headsetInputMeterPeak[0] = meterMin;
					headsetOutputMeterPeak[0] = meterMin;
					
					aec1MeterPeaks[0] = meterMin;
					aec1MeterPeaks[1] = meterMin;
					aec1MeterPeaks[2] = meterMin;
					
					aec2MeterPeaks[0] = meterMin;
					aec2MeterPeaks[1] = meterMin;
					aec2MeterPeaks[2] = meterMin;
					
					mic1CapsuleMeterPeaks[0] = meterMin;
					mic1CapsuleMeterPeaks[1] = meterMin;
					mic1CapsuleMeterPeaks[2] = meterMin;
					mic1CapsuleMeterPeaks[3] = meterMin;
					mic1CapsuleMeterPeaks[4] = meterMin;
					mic1CapsuleMeterPeaks[5] = meterMin;
					mic1CapsuleMeterPeaks[6] = meterMin;
					mic1CapsuleMeterPeaks[7] = meterMin;
					
						
					mic2CapsuleMeterPeaks[0] = meterMin;
					mic2CapsuleMeterPeaks[1] = meterMin;
					mic2CapsuleMeterPeaks[2] = meterMin;
					mic2CapsuleMeterPeaks[3] = meterMin;
					mic2CapsuleMeterPeaks[4] = meterMin;
					mic2CapsuleMeterPeaks[5] = meterMin;
					mic2CapsuleMeterPeaks[6] = meterMin;
					mic2CapsuleMeterPeaks[7] = meterMin;
					
					headsetMeterPeaks[0] = meterMin;
					headsetMeterPeaks[1] = 0; // don't draw peak for this meter type
					headsetMeterPeaks[2] = meterMin;					
				}
				
				// last check if the mic type has changed
				if (obj.microphoneType != microphoneType && obj.microphoneType != "0")
				{
					microphoneType = obj.microphoneType;
					populateLocationCombos(microphoneType);
					
					if (microphoneType == "1")
					{
						bfElevatOverrideCh1.selectedIndex = 1;
						bfElevatOverrideCh2.selectedIndex = 1;
					}
					else if (microphoneType == "2")
					{
						bfElevatOverrideCh1.selectedIndex = 2;
						bfElevatOverrideCh2.selectedIndex = 2;
					}
				}
            }

            setTimeout(startMeteringBasic, 50);
        },
        error: function (jqXHR, textStatus, errorThrown) {
        }
    });
}

function populateLocationCombos(microphoneType)
{
	if (microphoneType == "1")
	{
		micLocationCh1.options.length = 0;
		micLocationCh1.options[0] = new Option("Middle of the Table", "0", true, false);
		micLocationCh1.options[1] = new Option("End of the Table", "1", false, false);
		
		micLocationCh2.options.length = 0;
		micLocationCh2.options[0] = new Option("Middle of the Table", "0", true, false);
		micLocationCh2.options[1] = new Option("End of the Table", "1", false, false);

	}
	else if (microphoneType == "2")
	{
		micLocationCh1.options.length = 0;
		micLocationCh1.options[0] = new Option("Ceiling", "0", true, false);						
		
		micLocationCh2.options.length = 0;
		micLocationCh2.options[0] = new Option("Ceiling", "0", true, false);						
	}
}

function prepareMeteringCanvas() {
    mic1contextbg.lineWidth = 1;
    mic1contextbg.beginPath();

    drawBackground(mic1contextbg, mic1canvasbg, 1, meterX, meterY, meterWidth, meterHeight, "Input Meter", "", true, "", multiColorlabels);
    drawBackground(mic1contextbg, mic1canvasbg, capsuleMeterCount, meterX + 120, meterY, meterWidth, meterHeight, "Capsule Meters", "Azimuth Angle", true, "", multiColorlabels);

    drawBackground(mic2contextbg, mic2canvasbg, 1, meterX, meterY, meterWidth, meterHeight, "Input Meter", "", true, "", multiColorlabels);
    drawBackground(mic2contextbg, mic2canvasbg, capsuleMeterCount, meterX + 120, meterY, meterWidth, meterHeight, "Capsule Meters", "Azimuth Angle", true, "", multiColorlabels);

    drawBackground(softCodecCanvasbgContext, softCodecCanvasbg, 1, meterX, meterY, meterWidth, meterHeight, "Input", "", true, "", multiColorlabels);
    drawBackground(softCodecCanvasbgContext, softCodecCanvasbg, 1, meterX + meterWidth + meterGap, meterY, meterWidth, meterHeight, "Output", "", true, "", multiColorlabels);

    drawBackground(headsetCanvasbgContext, headsetCanbg, 1, meterX, meterY, meterWidth, meterHeight, "Input", "", true, "", multiColorlabels);
    drawBackground(headsetCanvasbgContext, headsetCanbg, 1, meterX + meterWidth + meterGap, meterY, meterWidth, meterHeight, "Output", "", true, "", multiColorlabels);

    drawBackground(outputCanvasbgContext, outputCanbg, 1, meterX, meterY, meterWidth, meterHeight, "Amp", "", true, "", multiColorlabels);
    drawBackground(outputCanvasbgContext, outputCanbg, 1, meterX + meterWidth + meterGap, meterY, meterWidth, meterHeight, "RCA", "", true, "", multiColorlabels);

    drawBackground(aecCanvasbgContext, aecCanvasbg, 1, meterX, meterY, meterWidth, meterHeight, "Ref 1", "", true, "", multiColorlabels);
    drawBackground(aecCanvasbgContext, aecCanvasbg, 1, meterX + meterWidth + meterGap, meterY, meterWidth, meterHeight, "ERL 1", "", false, colors.offRedColor, erlLabels);
    drawBackground(aecCanvasbgContext, aecCanvasbg, 1, meterX + ((meterWidth + meterGap) * 2), meterY, meterWidth, meterHeight, "ERLE 1", "", false, colors.offRedColor, erleLabels);

    drawBackground(aecCanvasbgContext, aecCanvasbg, 1, meterX + agcMeterGap + ((meterWidth + meterGap) * 3), meterY, meterWidth, meterHeight, "Ref 2", "", true, "", multiColorlabels);
    drawBackground(aecCanvasbgContext, aecCanvasbg, 1, meterX + agcMeterGap + ((meterWidth + meterGap) * 4), meterY, meterWidth, meterHeight, "ERL 2", "", false, colors.offRedColor, erlLabels);
    drawBackground(aecCanvasbgContext, aecCanvasbg, 1, meterX + agcMeterGap + ((meterWidth + meterGap) * 5), meterY, meterWidth, meterHeight, "ERLE 2", "", false, colors.offRedColor, erleLabels);
    
    drawBackground(noiseGatecanbgContext, noiseGatecanbg, 1, meterX, meterY, meterWidth, meterHeight, "Input", "", true, "", multiColorlabels);
    drawBackground(noiseGatecanbgContext, noiseGatecanbg, 1, meterX + meterWidth + meterGap, meterY, meterWidth, meterHeight, "Attenuation", "", false, colors.offRedColor, attenuationLabels);
    drawBackground(noiseGatecanbgContext, noiseGatecanbg, 1, meterX + ((meterWidth + meterGap) * 2), meterY, meterWidth, meterHeight, "Post Gate", "", true, "", multiColorlabels);
}

function drawBackground(context, canvas, mCount, xPos, yPos, mWidth, mHeight, title, azimuthTitle, multiColor, color, labels) {

    // work out ranges			
	var location = 0;
    var bottom = yPos + mHeight;
    var lastIndex = labels.length - 1;
    var xMeterMin = labels[lastIndex];
    var xMeterMax = labels[0];
    var range = xMeterMax - xMeterMin;

    // Draw Titles
    context.font = '13px OpenSansRegular';
    context.fillStyle = 'white';
    context.textAlign = "center";
    context.fillText(title, (xPos - textXOffset) + (mCount * mWidth), yPos + mHeight + 35);

    // Draw Title
    context.fillText(azimuthTitle, azimuthXOffset, yPos + mHeight + 35);

    // Draw labels
    context.font = '9px OpenSansRegular';
    context.fillStyle = 'white';
    context.textAlign = "center";

    for (var i = 0; i < labels.length; i++) {

        var labelValue = labels[i];
        var y = bottom - ((labelValue - xMeterMin) / range) * mHeight;
        var textValue = labelValue;

        if (labelValue > 0) {
            textValue = "+" + textValue;
        }

        context.fillText(textValue, xPos - textXOffset, y + textYOffset);
    }

	// Draw meter background
    for (var i = 0; i < mCount; i++) {

        context.fillStyle = '#000000';
        context.fillRect(xPos + location, yPos + mHeight, mWidth, 20);

        if (multiColor) {
            context.fillStyle = '#333';
            context.fillStyle = colors.offGreenColor;
			
            rangeMin = 0;
            rangeMax = ((warmMeterMin - xMeterMin) / range) * mHeight;
            hght = rangeMin - rangeMax;
            y1 = yPos + mHeight;
            context.fillRect(xPos + location, y1, mWidth, hght);

            context.fillStyle = colors.offYellowColor;
            y1 += hght;
            rangeMin = ((warmMeterMin - xMeterMin) / range) * mHeight;
            rangeMax = ((hotMeterMin - xMeterMin) / range) * mHeight;
            hght = rangeMin - rangeMax;
            context.fillRect(xPos + location, y1, mWidth, hght);
            warmMeterMinLevel = rangeMin;

            context.fillStyle = colors.offRedColor;
            y1 += hght;
            rangeMin = ((hotMeterMin - xMeterMin) / range) * mHeight;
            rangeMax = ((xMeterMax - xMeterMin) / range) * mHeight;
            hght = rangeMin - rangeMax;
            context.fillRect(xPos + location, y1, mWidth, hght);
            hotMeterMinLevel = rangeMin;
        }
        else {
            context.fillStyle = color;
            context.fillRect(xPos + location, yPos, mWidth, mHeight);
        }

        location += meterGap; // Move to the next meter x location
    }
}

function drawMeters(context, canvas, meterValues, startIndex, xPos, yPos, numberOfMeters, mWidth, mHeight, dbOffSet, convertToDB, multiColor, color, xMeterMin, xMeterMax, peakValues) {

    context.clearRect(xPos, yPos, canvas.width, canvas.height);
    xPosGap = 0;

    if (meterValues.length > 0) {

        var range = xMeterMax - xMeterMin;

        for (var i = startIndex; i < numberOfMeters + startIndex; i++) {
            var dbValue = parseFloat(meterValues[i]);
			var peakdBValue = parseFloat(peakValues[i]);
			
			if (dbValue > peakdBValue)
			{
				peakValues[i] = dbValue; // store the highest peak value
			}
			
            if (convertToDB) {
				if (dbValue > minus120dB)	{
					dbValue = (log10(dbValue) * 20) + dbOffSet;
				}
				else
				{
					dbValue = xMeterMin;
				}
				
				if (peakdBValue > minus120dB)	{
					peakdBValue = (log10(peakdBValue) * 20) + dbOffSet;
				}
				else
				{
					peakdBValue = xMeterMin;
				}
            }

	
			// Clamp the levels if they are out of range
			if (xMeterMin > xMeterMax) { // for meters that draw down from the minimum value
	            if (dbValue < xMeterMax) {
	                dbValue = xMeterMax;
	            }
	            
	            if (peakdBValue < xMeterMax) {
	                peakdBValue = xMeterMax;
	            }
			}
			else
			{
	            if (dbValue > xMeterMax) { // for meters that draw up from the minumum value
	                dbValue = xMeterMax;
	            }
	            
	            if (peakdBValue > xMeterMax) {
	                peakdBValue = xMeterMax;
	            }
            }

			var textValue = dbValue.toFixed(1);

			// Calculate the level values (pixel xPos)			
            var tempLevel = ((dbValue - xMeterMin) / range) * mHeight;
            var level = Math.round(tempLevel);
			
			tempLevel = ((peakdBValue - xMeterMin) / range) * mHeight;
			var peakLevel = Math.round(tempLevel);
			
			// Check if we have to show infinity symbol
            if (textValue == "NaN") {
                textValue = "∞";
                level = xMeterMin;
            }
			
            // draw the meter value
            drawLevel(context, level, xPos + xPosGap, yPos + mHeight, mWidth, multiColor, color, peakLevel);

            // draw meter level text
            context.font = '9px OpenSansRegular';
            context.fillStyle = 'white';
            context.textAlign = "center";
            context.fillText(textValue, xPos + xPosGap + (mWidth / 2), yPos + mHeight + 13);
            xPosGap += meterGap; // Move to the next meter x location
        }
    }
}

function log10(val) {
    return Math.log(val) / Math.LN10;
}

function updateLoudspeakerEqCombos() {

	var overrideAutoSetupEqValue = document.getElementById('overrideAutoSetupEq').checked;
    document.getElementById('autoSetupBassEq').disabled = overrideAutoSetupEqValue == false;
    document.getElementById('autoSetupMidEq').disabled = overrideAutoSetupEqValue == false;
	document.getElementById('autoSetupTrebleEq').disabled = overrideAutoSetupEqValue == false;
}


function drawLevel(context, value, xPos, yPos, width, multiColor, color, peak) {

    context.fillStyle = colors.offGreenColor;

    if (multiColor) {

        if (value > hotMeterMinLevel) {
            context.fillStyle = colors.onRedColor;
            context.fillRect(xPos, yPos - hotMeterMinLevel, width, (value - hotMeterMinLevel) * -1);
        }

        if (value > warmMeterMinLevel) {
            context.fillStyle = colors.onYellowColor;

            if (value < hotMeterMinLevel) {
                context.fillRect(xPos, yPos - warmMeterMinLevel, width, (value - warmMeterMinLevel) * -1);
            }
            else {
                context.fillRect(xPos, yPos - warmMeterMinLevel, width, (hotMeterMinLevel + 1 - warmMeterMinLevel) * -1);
            }
        }

        context.fillStyle = colors.onGreenColor;

        if (value < warmMeterMinLevel) {
            if (value > 0) {
                context.fillRect(xPos, yPos, width, value * -1);
            }
        }
        else {
            context.fillRect(xPos, yPos, width, (warmMeterMinLevel + 1) * -1);
        }
		
		// Peak Meter
		if (peak > 0) {
			if (peak > hotMeterMinLevel) {
				context.fillStyle = colors.onRedColor;
			}
			else if (peak > warmMeterMinLevel) {
				context.fillStyle = colors.onYellowColor;
			}
			else {
				context.fillStyle = colors.onGreenColor;
			}
			context.fillRect(xPos, (yPos - peak), width, 1);
		}
    }
    else {
        context.fillStyle = color;
        context.fillRect(xPos, yPos, width, value * -1);
		
		if (peak > 0) {
			context.fillRect(xPos, (yPos - peak), width, 1);
		}
    }
}

function drawAzimuth(context, b1, b2, b3, p1, p2, p3, xPos, yPos, radius, hideLeftRightMarkers) {
    context.beginPath();
    context.arc(xPos, yPos, radius, 0, 2 * Math.PI, false);
    context.fillStyle = "black";
    context.fill();
    context.lineWidth = 2;
    context.strokeStyle = '#484849';
    context.stroke();

	// Draw disabled area when mic is at the end of the table
	if (hideLeftRightMarkers) {
		context.beginPath();
		context.arc(xPos, yPos, radius - 14, Math.PI / 6, 5 * Math.PI / 6, true);
		context.lineWidth = 26;
		context.strokeStyle = colors.disabledMarkerColor;
		context.stroke();
	}
	
    context.beginPath();
	context.fillStyle = "black";
    context.arc(xPos, yPos, radius - 30, 0, 2 * Math.PI, false);
    context.lineWidth = 6;
    context.strokeStyle = colors.leftMarkerColor;
    context.stroke();

    azimuthAngle = 360 - parseInt(b1) + 90;
    radianAngle = azimuthAngle * (Math.PI / 180);
    azxPos = xPos + (radius - 6) * Math.cos(azimuthAngle * (Math.PI / 180));
    azyPos = yPos + (radius - 6) * Math.sin(azimuthAngle * (Math.PI / 180));
    drawEllipse(context, azxPos, azyPos, 10, 35, getShaderColor(colors.bottomMarkerColor, p1), radianAngle);

	if (hideLeftRightMarkers == false) {
		azimuthAngle = 360 - parseInt(b2) + 90;
		azxPos = xPos + (radius - 6) * Math.cos(azimuthAngle * (Math.PI / 180));
		azyPos = yPos + (radius - 6) * Math.sin(azimuthAngle * (Math.PI / 180));
		radianAngle = azimuthAngle * (Math.PI / 180);
		drawEllipse(context, azxPos, azyPos, 10, 35, getShaderColor(colors.leftMarkerColor, p2), radianAngle);
		
		azimuthAngle = 360 - parseInt(b3) + 90;
		azxPos = xPos + (radius - 6) * Math.cos(azimuthAngle * (Math.PI / 180));
		azyPos = yPos + (radius - 6) * Math.sin(azimuthAngle * (Math.PI / 180));
		radianAngle = azimuthAngle * (Math.PI / 180);
		drawEllipse(context, azxPos, azyPos, 10, 35, getShaderColor(colors.rightMarkerColor, p3), radianAngle);
	}
}

function getShaderColor(col, amt) {

    col = String(col).replace(/[^0-9a-f]/gi, '');
    var weight = parseFloat(amt);

    var num = parseInt(col, 16);
    var r = parseInt((num >> 16) * weight, 10);

    if (r > 255) r = 255;
    else if (r < 0) r = 0;

    var g = parseInt(((num >> 8) & 0x00FF) * weight, 10);

    if (g > 255) g = 255;
    else if (g < 0) g = 0;

    var b = parseInt((num & 0x0000FF) * weight, 10);

    if (b > 255) b = 255;
    else if (b < 0) b = 0;

    return ("#" + (b | (g << 8) | (r << 16)).toString(16));
}

function drawEllipse(context, xC, yC, width, height, shadeColor, rotation) {

    context.save();
    context.beginPath();

    var x, y, rW, rH, inc;
    inc = 0.01 //value by which we increment the angle in each step
    rW = width / 2; //horizontal radius
    rH = height / 2; //vertical radius
    x = xC + rW * Math.cos(rotation); // ...we will treat this as angle = 0
    y = yC + rW * Math.sin(rotation);

    context.moveTo(x, y); //set the starting position
    var weight = parseFloat(String(shadeColor).replace(/[^0-9a-f]/gi, ''));

    for (var angle = inc; angle < 2 * Math.PI; angle += inc) { //increment the angle from just past zero to full circle (2 Pi radians)
        x = xC + rW * Math.cos(angle) * Math.cos(rotation) - rH * Math.sin(angle) * Math.sin(rotation);
        y = yC + rW * Math.cos(angle) * Math.sin(rotation) + rH * Math.sin(angle) * Math.cos(rotation);
        context.lineTo(x, y); //draw a straight line segment. if the increment is small enough, this will be
        //indistinguishable from a curve in an on-screen pixel array
    }

    context.lineWidth = 2;
    context.fillStyle = shadeColor;
    context.fill();
    context.closePath()
    context.restore();
}
